#ifndef KEYVALUE_H
#define KEYVALUE_H
#include "common.h"

/**
 * KeyValue entry for Slot.
 * @author Brian Demsky <bdemsky@uci.edu>
 * @version 1.0
 */

class KeyValue {/*extends Entry */
private:
	IoTString *key;
	IoTString *value;

public:
	KeyValue(IoTString *_key, IoTString *_value) :
		key(_key),
		value(_value) {
	}

	IoTString *getKey() { return key; }
	IoTString *getValue() { return value; }
	void encode(ByteBuffer *bb);
	int32_t getSize();
	KeyValue *getCopy();
};

KeyValue *KeyValue_decode(ByteBuffer *bb);
#endif
