#include "NewKey.h"
#include "ByteBuffer.h"
#include "IoTString.h"

Entry *decode(Slot *slot, ByteBuffer *bb) {
	int keylength = bb->getInt();
	Array<char> *key = new Array<char>(keylength);
	bb->get(key);
	int64_t machineid = bb->getLong();

	return new NewKey(slot, IoTString_shallow(key), machineid);
}

void NewKey::encode(ByteBuffer *bb) {
	bb->put(TypeNewKey);
	bb->putInt(key->length());
	bb->put(key->internalBytes());
	bb->putLong(machineid);
}

int NewKey::getSize() {
	return sizeof(int64_t) + sizeof(char) + sizeof(int32_t) + key->length();
}
